﻿using System;
using System.Collections.Generic;
using IdeaBlade.Validation;

// ReSharper disable UseObjectOrCollectionInitializer

namespace AdvancedNorthwindModel
{
    public class AdvancedNorthwindVerifierProvider : IVerifierProvider
    {
        public IEnumerable<Verifier> GetVerifiers(object verifierProviderContext)
        {
            var verifiers = new List<Verifier>
                {
                  MakeNotEmptyGuidVerifier<Customer>(
                      Customer.PropertyMetadata.CustomerID.Name),

                  MakeNotEmptyGuidVerifier<Order>(
                      Order.PropertyMetadata.CustomerID.Name),
                };

            return verifiers;
        }

        private static Verifier MakeNotEmptyGuidVerifier<T>(string propertyName)
        {
            Verifier v = new NotEmptyGuidVerifier(typeof(T), propertyName);
            // Set the message to display when invalid
            v.VerifierArgs.ErrorMessageInfo.ErrorMessage =
                String.Format("{0} cannot be empty", propertyName);
            return v;
        }

    }
}