using System.Runtime.Serialization;
using IdeaBlade.EntityModel;

namespace AdvancedNorthwindModel {

  /// <summary>
  /// Slice of the Employee class for use in a projection
  /// </summary>
  [DataContract]
  public class EmployeeSlice : IKnownType {

    // Employee properties
    [DataMember]
    public int EmployeeID { get; set; }
    [DataMember]
    public string FirstName { get; set; }
    [DataMember]
    public string LastName { get; set; }

    // Calculated property
    public string FullName { get { return FirstName + " " + LastName; } }

    // Aggregation of values from an Employee navigation property
    [DataMember]
    public int OrderCount { get; set; }
  }
}