using System;
using IdeaBlade.Validation;

// General purpose custom verifiers
namespace AdvancedNorthwindModel
{
    /// <summary>
    /// Ensure that the Guid property value is not the empty Guid
    /// </summary>
    public class NotEmptyGuidVerifier : PropertyValueVerifier
    {

        public NotEmptyGuidVerifier(
            Type entityType, String propertyName,
            String displayName = null, bool? treatEmptyStringAsNull = null)
            : base(new PropertyValueVerifierArgs(
                entityType, propertyName, false,
                displayName, treatEmptyStringAsNull)) { }

        protected override VerifierResult VerifyValue(
            object itemToVerify, object valueToVerify,
            TriggerContext triggerContext, VerifierContext verifierContext)
        {
            return new VerifierResult(
                !Equals(valueToVerify,Guid.Empty));
        }
    }

}
