﻿Imports IdeaBlade.Extensions
Imports Microsoft.Silverlight.Testing
Imports Microsoft.VisualStudio.TestTools.UnitTesting

' ReSharper disable InconsistentNaming

Namespace WorkingWithEntities.SystemUtilityTests
	''' <summary>
	''' Demonstrate SystemTime utility class
	''' </summary>
	<TestClass>
	Public Class When_using_SystemTime
		<TestMethod, Tag("SystemTime")>
		Public Sub can_override_NowFn()
			Dim expect = Date.Now

      System.Threading.Thread.Sleep(1000)
			Assert.AreNotEqual(expect, Date.Now, "NowFn not replaced")

			SystemTime.NowFn = Function() expect
			Assert.AreEqual(expect, SystemTime.Now(), "Not same 1st time")
			System.Threading.Thread.Sleep(1)
			Assert.AreEqual(expect, SystemTime.Now(), "Not same 2nd time")

			SystemTime.ResetNowFn()
			Assert.AreNotEqual(expect, SystemTime.Now(), "NowFn restore failed")
		End Sub
	End Class

  ''' <summary>
  ''' Demonstrate SystemGuid utility class
  ''' </summary>
  <TestClass>
  Public Class When_using_SystemGuid
	<TestMethod, Tag("SystemGuid")>
	Public Sub can_override_NewGuidFn()
		Dim expect = Guid.NewGuid()
		Assert.AreNotEqual(expect, Guid.NewGuid(), "NewGuidFn not replaced")

		SystemGuid.NewGuidFn = Function() expect
		Assert.AreEqual(expect, SystemGuid.NewGuid(), "Not same 1st time")
		Assert.AreEqual(expect, SystemGuid.NewGuid(), "Not same 2nd time")

		SystemGuid.ResetNewGuidFn()
		Assert.AreNotEqual(expect, SystemGuid.NewGuid(), "NewGuidFn restore failed")

	End Sub
  End Class
End Namespace